class SystemSimpleCollison extends System {
    private _screenData;
    constructor (screenData: ScreenData);
    public start(): void;
    public update(dt: number, t: number): void;
    public end(): void;
}
class SystemKeyboardInput extends System {
    private _keyInput;
    private _screenData;
    private _map;
    constructor (keyInput: KeyInput, screenData: ScreenData, map: any);
    public start(): void;
    public update(dt: number, t: number): void;
    public end(): void;
}
class PlayerNode extends SystemNode {
    public position: ComponentPosition;
    public velocity: ComponentVelocity;
    public display: ComponentDisplay;
    public animation: ComponentAnimation;
}
class Game extends Engine {
    private _keyInput;
    private _screenData;
    private _tileSize;
    private _map;
    constructor (canvas, width, height);
    public postPreload(): void;
    public createTileType(id: number, type: number): Sprite;
    public createPlayer(): Sprite;
}
