var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var SystemSimpleCollison = (function (_super) {
    __extends(SystemSimpleCollison, _super);
    function SystemSimpleCollison(screenData) {
        _super.call(this);
        this._screenData = null;
        this._screenData = screenData;
        Debug.log("SystemSimpleCollison* init complete");
    }
    SystemSimpleCollison.prototype.start = function () {
        Debug.log("SystemSimpleCollison* start");
    };
    SystemSimpleCollison.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            for(var othernode = this.nodelist.head; othernode; othernode = othernode.next) {
                if(othernode != node) {
                    var dist = Math.sqrt((node.position.x - othernode.position.x) * (node.position.x - othernode.position.x) + (node.position.y - othernode.position.y) * (node.position.y - othernode.position.y));
                    if(dist < (node.display.width / 2 + othernode.display.width / 2)) {
                        node.velocity.x = 0;
                        node.velocity.y = 0;
                        othernode.velocity.x = 0;
                        othernode.velocity.y = 0;
                    }
                }
            }
            if(node.position.x > this._screenData.width + 10) {
                node.position.x = -12;
            } else {
                if(node.position.x < -12) {
                    node.position.x = this._screenData.width + 12;
                }
            }
            if(node.position.y > this._screenData.height + 12) {
                node.position.y = -12;
            } else {
                if(node.position.y < -12) {
                    node.position.y = this._screenData.height + 12;
                }
            }
        }
    };
    SystemSimpleCollison.prototype.end = function () {
        Debug.log("SystemKeyboardInput* end");
    };
    return SystemSimpleCollison;
})(System);
var SystemKeyboardInput = (function (_super) {
    __extends(SystemKeyboardInput, _super);
    function SystemKeyboardInput(keyInput, screenData, map) {
        _super.call(this);
        this._keyInput = null;
        this._screenData = null;
        this._map = null;
        this._keyInput = keyInput;
        this._screenData = screenData;
        this._map = map;
        this.nodelist = ManagerSystemNode.instance.getList(PlayerNode);
        Debug.log("SystemKeyboardInput* init complete");
    }
    SystemKeyboardInput.prototype.start = function () {
        Debug.log("SystemKeyboardInput* start");
    };
    SystemKeyboardInput.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            if(node.velocity.x > 1080) {
                node.velocity.x = 1080;
            }
            if(node.velocity.y > 1080) {
                node.velocity.y = 1080;
            }
            if(this._keyInput.keyIsDown(KeyInput.LEFT)) {
                if(this._keyInput.keyIsDown(KeyInput.UP)) {
                    node.position.x -= 110 * dt;
                    node.position.y -= 110 * dt;
                    node.animation.currentAnimationTag = "walk_leftup";
                } else {
                    if(this._keyInput.keyIsDown(KeyInput.DOWN)) {
                        node.position.x -= 110 * dt;
                        node.position.y += 110 * dt;
                        node.animation.currentAnimationTag = "walk_leftdown";
                    } else {
                        node.position.x -= 140 * dt;
                        node.animation.currentAnimationTag = "walk_left";
                    }
                }
            } else {
                if(this._keyInput.keyIsDown(KeyInput.RIGHT)) {
                    if(this._keyInput.keyIsDown(KeyInput.UP)) {
                        node.position.x += 110 * dt;
                        node.position.y -= 110 * dt;
                        node.animation.currentAnimationTag = "walk_rightup";
                    } else {
                        if(this._keyInput.keyIsDown(KeyInput.DOWN)) {
                            node.position.x += 110 * dt;
                            node.position.y += 110 * dt;
                            node.animation.currentAnimationTag = "walk_rightdown";
                        } else {
                            node.position.x += 140 * dt;
                            node.animation.currentAnimationTag = "walk_right";
                        }
                    }
                }
            }
            if(this._keyInput.keyIsDown(KeyInput.UP) && !this._keyInput.keyIsDown(KeyInput.LEFT) && !this._keyInput.keyIsDown(KeyInput.RIGHT)) {
                node.position.y -= 140 * dt;
                node.animation.currentAnimationTag = "walk_up";
            } else {
                if(this._keyInput.keyIsDown(KeyInput.DOWN) && !this._keyInput.keyIsDown(KeyInput.LEFT) && !this._keyInput.keyIsDown(KeyInput.RIGHT)) {
                    node.position.y += 140 * dt;
                    node.animation.currentAnimationTag = "walk_down";
                }
            }
        }
    };
    SystemKeyboardInput.prototype.end = function () {
        Debug.log("SystemKeyboardInput* end");
    };
    return SystemKeyboardInput;
})(System);
var PlayerNode = (function (_super) {
    __extends(PlayerNode, _super);
    function PlayerNode() {
        _super.apply(this, arguments);

        this.position = null;
        this.velocity = null;
        this.display = null;
        this.animation = null;
    }
    return PlayerNode;
})(SystemNode);
var Game = (function (_super) {
    __extends(Game, _super);
    function Game(canvas, width, height) {
        var _this = this;
        _super.call(this, canvas, width, height);
        this._keyInput = null;
        this._screenData = null;
        this._tileSize = 64;
        this._map = [
            [
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    3
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    0, 
                    4
                ], 
                [
                    1, 
                    9
                ]
            ], 
            [
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ], 
                [
                    1, 
                    9
                ]
            ]
        ];
        this._screenData = new ScreenData(canvas, width, height);
        this._keyInput = new KeyInput();
        this.managerAsset.addWithTag("./bin/assets/image/player.png", ManagerAsset.TYPE_ATLAS, "playerAtlas");
        this.managerAsset.addWithTag("./bin/assets/image/tiles.png", ManagerAsset.TYPE_ATLAS, "tilesAtlas");
        this.managerAsset.queueLoad(function () {
            return _this.postPreload();
        });
    }
    Game.prototype.postPreload = function () {
        this.managerSystem.addWithTag(new SystemKeyboardInput(this._keyInput, this._screenData, this._map), "main", ManagerSystem.PRIORITY_INPUT);
        var cnt = 0;
        for(var i = 0; i < this._map.length; i++) {
            for(var j = 0; j < this._map[0].length; j++) {
                var tile = this.createTileType(cnt, this._map[i][j][1]);
                tile.position.x = j * this._tileSize;
                tile.position.y = (i * this._tileSize) + this._tileSize;
                cnt++;
            }
        }
        var player = this.createPlayer();
        this.setCoreRunning(true);
    };
    Game.prototype.createTileType = function (id, type) {
        var spr = new Sprite(id.toString(), "tilesAtlas", true);
        spr.animation.addWithTag("idle", [
            'tile' + type + '.png'
        ]);
        spr.animation.currentAnimationTag = "idle";
        return spr;
    };
    Game.prototype.createPlayer = function () {
        var player = new Sprite("player", "playerAtlas", true);
        player.position.origin.x = 32;
        player.position.origin.y = 32;
        player.position.x = (64 * 14) - 32;
        player.position.y = (64 * 3) - 32;
        player.animation.addWithTag("walk_right", [
            "player_facing_r.png"
        ]);
        player.animation.addWithTag("walk_rightdown", [
            "player_facing_dr.png"
        ]);
        player.animation.addWithTag("walk_down", [
            "player_facing_d.png"
        ]);
        player.animation.addWithTag("walk_leftdown", [
            "player_facing_dl.png"
        ]);
        player.animation.addWithTag("walk_left", [
            "player_facing_l.png"
        ]);
        player.animation.addWithTag("walk_leftup", [
            "player_facing_ul.png"
        ]);
        player.animation.addWithTag("walk_up", [
            "player_facing_u.png"
        ]);
        player.animation.addWithTag("walk_rightup", [
            "player_facing_ur.png"
        ]);
        player.animation.addWithTag("dead", [
            "player_dead.png"
        ]);
        player.animation.currentAnimationTag = "walk_right";
        var playerNode = new PlayerNode(player);
        playerNode.position = player.position;
        playerNode.display = player.display;
        playerNode.velocity = player.velocity;
        playerNode.animation = player.animation;
        ManagerSystemNode.instance.addToList(playerNode, PlayerNode);
        return player;
    };
    return Game;
})(Engine);
