/**
 * SystemOriginPoint
 */
class SystemKeyboardInput extends System
{
	// properties
	private _keyInput:KeyInput 			= null;
	private _screenData:ScreenData 		= null;
	private _map:any					= null;


	// constructor
	constructor(keyInput:KeyInput, screenData:ScreenData, map:any)
	{
		super();

		// store input for use
		this._keyInput 		= keyInput;
		this._screenData 	= screenData;
		this._map			= map;

		// create the node list
		this.nodelist = ManagerSystemNode.instance.getList(PlayerNode);

		Debug.log("SystemKeyboardInput* init complete");
	}



	public start():void
	{
		Debug.log("SystemKeyboardInput* start");
	}



	public update(dt:number, t:number):void
	{
		for(var node = this.nodelist.head; node; node = node.next)
		{
			// velocity limits
			if(node.velocity.x > 1080) node.velocity.x = 1080;
			if(node.velocity.y > 1080) node.velocity.y = 1080;

			// move
			if(this._keyInput.keyIsDown(KeyInput.LEFT))
			{
				if(this._keyInput.keyIsDown(KeyInput.UP))
				{
					node.position.x -= 110 * dt;
					node.position.y -= 110 * dt;
					node.animation.currentAnimationTag = "walk_leftup";
				} else if(this._keyInput.keyIsDown(KeyInput.DOWN))
				{
					node.position.x -= 110 * dt;
					node.position.y += 110 * dt;
					node.animation.currentAnimationTag = "walk_leftdown";
				} else
				{
					node.position.x -= 140 * dt;
					node.animation.currentAnimationTag = "walk_left";
				}
			} else if(this._keyInput.keyIsDown(KeyInput.RIGHT))
			{
				if(this._keyInput.keyIsDown(KeyInput.UP))
				{
					node.position.x += 110 * dt;
					node.position.y -= 110 * dt;
					node.animation.currentAnimationTag = "walk_rightup";
				} else if(this._keyInput.keyIsDown(KeyInput.DOWN))
				{
					node.position.x += 110 * dt;
					node.position.y += 110 * dt;
					node.animation.currentAnimationTag = "walk_rightdown";
				} else
				{
					node.position.x += 140 * dt;
					node.animation.currentAnimationTag = "walk_right";
				}
			}

			if(this._keyInput.keyIsDown(KeyInput.UP) && !this._keyInput.keyIsDown(KeyInput.LEFT) && !this._keyInput.keyIsDown(KeyInput.RIGHT))
			{
				node.position.y -= 140 * dt;
				node.animation.currentAnimationTag = "walk_up";
			} else if(this._keyInput.keyIsDown(KeyInput.DOWN) && !this._keyInput.keyIsDown(KeyInput.LEFT) && !this._keyInput.keyIsDown(KeyInput.RIGHT))
			{
				node.position.y += 140 * dt;
				node.animation.currentAnimationTag = "walk_down";
			}
		}
	}



	public end():void
	{
		Debug.log("SystemKeyboardInput* end");
	}
}