/**
 * ManagerEntity stores reference to all Entities
 */
class ManagerEntity
{
	// properties
	public static instance:ManagerEntity 	= null;

	private _entities:Entity[]				= null;
	private _entitiesCount:number			= 0;


	// Getters / Setters
	public entityCount():number   { return this._entitiesCount; }


	// constructor
	constructor()
	{
		// setup instance
		if(ManagerEntity.instance == null)
		{
			ManagerEntity.instance = this;

			this._entities = new Entity[];
		}

		Debug.log("ManagerEntity* init");
	}


	public getWithTag(tag:string):Entity
	{
		if(this._entities[tag] != undefined)
		{
			return this._entities[tag];
		} else
		{
			Debug.warn("ManagerEntity* tag not used");
		}
	}


	public addWithTag(entity:Entity, tag:string):void
	{
		if(this._entities[tag] == undefined)
		{
			this._entities[tag] = entity;
			this._entitiesCount++;

		// notify
		entity.onAddedToGame();
		} else
		{
			Debug.warn("ManagerEntity* tag already used for Entity");
		}
	}


	public removeWithTag(tag:string):void
	{
		if(this._entities[tag] != undefined)
		{
			// notify
			this._entities[tag].onRemoveFromGame();

			this._entities[tag] = undefined;
			this._entitiesCount--;
		} else
		{
			Debug.warn("ManagerEntity* tag not found: " + tag);
		}
	}
}