/**
 *	ManagerSystemNode is responsible for tracking NodeLists
 */
class ManagerSystemNode
{
	// members
	public static instance:ManagerSystemNode	= null;

	private _nodeList:SystemNodeList[]  		= null;


	// constructor
	constructor()
	{
		// setup instance
		if(ManagerSystemNode.instance == null)
		{
			ManagerSystemNode.instance = this;

			this._nodeList = new SystemNodeList[];
		}

		Debug.log("ManagerSystemNode* init");
	}


	public addToList(node:SystemNode, type):void
	{
		// list creation if needed
		if(this._nodeList[type.name] == undefined)
		{
			this._nodeList[type.name] = new SystemNodeList();
			Debug.log("ManagerSystemNode* created node list: " + type.name);
		}

		this._nodeList[type.name].add(node);
	}


	public initList(type):void
	{
		// list creation if needed
		if(this._nodeList[type.name] == undefined)
		{
			this._nodeList[type.name] = new SystemNodeList();
		}
	}


	public getList(type):SystemNodeList
	{
		if(this._nodeList[type.name] != undefined)
		{
			return this._nodeList[type.name];
		} else
		{
			this.initList(type);
			return this._nodeList[type.name];
		}
	}
}