/**
 * SystemAnimation
 */
class SystemAnimation extends System
{
	// properties
	private _ctx		= null;



	// constructor
	constructor()
	{
		super();

		// create the node list
		this.nodelist = ManagerSystemNode.instance.getList(NodeAnimation);

		Debug.log("SystemAnimation* init complete");
	}



	public start():void
	{
		Debug.log("SystemAnimation* start");
	}



	public update(dt:number, t:number):void
	{
		for(var node = this.nodelist.head; node; node = node.next)
		{
			var currentAnimTag:string = node.animation.currentAnimationTag;
			if(node.animation.frameCounter < node.animation.getWithTag(currentAnimTag).length)
			{
				if(node.animation.frameskipCounter < node.animation.frameskip)
				{
					node.animation.frameskipCounter++;

				} else
				{
					var filename:string = node.animation.getWithTag(currentAnimTag)[node.animation.frameCounter];
					node.animation.currentFrame = node.animation.frames[filename];
					node.animation.frameCounter++;
					node.animation.frameskipCounter = 0;

					node.display.width 		= node.animation.currentFrame.frameWidth;
					node.display.height 	= node.animation.currentFrame.frameHeight;
				}
			} else
			{
				// TODO looping control
				node.animation.frameCounter = 0;
			}
		}
	}



	public end():void
	{
		Debug.log("SystemAnimation* end");
	}
}