class ScreenData
{
	// properties
	private _width:number 			= 0;
	private _height:number 			= 0;
	private _canvas:any				= null;

	// getters
	public get width():number 		{ return this._width; 	}
	public get height():number 		{ return this._height; 	}
	public get canvas():any 		{ return this._canvas; 	}



	/**
	 * constructor
	 *
	 * @property canvas 	- any
	 * @property width 		- number
	 * @property height 	- number
	 */
	constructor(canvas:any, width:number, height:number)
	{
		this._width 		= width;
		this._height 		= height;
		this._canvas		= canvas;

		// set size
		this._canvas.height = height;
		this._canvas.width 	= width;
	}



	/**
	 * set a background image to the canvas using CSS (static only)
	 *
	 * @property url 		- string
	 * @property repeat		- Bool
	 */
	public setBackgroundImage(url:string, repeat:bool = false):void
	{
		switch(repeat)
		{
			case true:
				this._canvas.style.background 			= "url(" + url + ")";
				this._canvas.style.backgroundRepeat 	= "repeat";
				break;

			case false:
				this._canvas.style.background 			= "url(" + url + ")";
				this._canvas.style.backgroundRepeat 	= "no-repeat";
				break;
		}
	}
}