class KeyInput
{
	// member
	private _pressed:bool[] 		= null;

	// constants
	static LEFT:number				= 37;
	static UP:number				= 38;
	static RIGHT:number				= 39;
	static DOWN:number				= 40;
	static CTRL:number				= 17;
	static SHIFT:number				= 16;
	static TAB:number				= 9;
	static W:number					= 87;
	static S:number					= 83;
	static A:number					= 65;
	static D:number					= 68;



	// constructor
	constructor()
	{
		this._pressed = new bool[];

		// register key listeners
		window.addEventListener('keyup',	(event) => this.onKeyUp(event),		false);
		window.addEventListener('keydown',	(event) => this.onKeyDown(event),	false);
		//window.addEventListener('keyup',	function(event) { this.onKeyup(event);	},		false);
		//window.addEventListener('keydown',	function(event) { this.onKeydown(event); }, 	false);
	}


	// check if a key is down
	public keyIsDown(keycode:number):bool
	{
		return this._pressed[keycode];
	}


	private onKeyDown(keycode:any):void
	{
		this._pressed[event.keyCode] = true;
	}

	private onKeyUp(keycode:any):void
	{
		//delete this._pressed[event.keyCode];
		this._pressed[event.keyCode] = false;
	}
}