var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var SystemBunnyMark = (function (_super) {
    __extends(SystemBunnyMark, _super);
    function SystemBunnyMark(screenData) {
        _super.call(this);
        this._screenData = null;
        this._stats = null;
        this._screenData = screenData;
        this.nodelist = ManagerSystemNode.instance.getList(NodeMovement);
        this._stats = new Stats();
        this._stats.domElement.style.position = 'absolute';
        this._stats.domElement.style.left = '0px';
        this._stats.domElement.style.top = '0px';
        this._stats.domElement.style.z = 1;
        document.body.appendChild(this._stats.domElement);
        Debug.log("SystemBunnyMark* init complete");
    }
    SystemBunnyMark.prototype.start = function () {
        Debug.log("SystemBunnyMark* start");
    };
    SystemBunnyMark.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            if(node.position.x > this._screenData.width - 30) {
                node.velocity.x *= -1;
            }
            if(node.position.x < 3) {
                node.velocity.x *= -1;
            }
            if(node.position.y > this._screenData.height - 40) {
                node.velocity.y *= -1;
            }
            if(node.position.y < 3) {
                node.velocity.y *= -1;
            }
        }
        this._stats.update();
    };
    SystemBunnyMark.prototype.end = function () {
        Debug.log("SystemBunnyMark* end");
    };
    return SystemBunnyMark;
})(System);
var Game = (function (_super) {
    __extends(Game, _super);
    function Game(canvas, width, height) {
        var _this = this;
        _super.call(this, canvas, width, height);
        this._screenData = null;
        this._bunnys = 50;
        Debug.debuggingEnabled = false;
        this._screenData = new ScreenData(canvas, width, height);
        this.managerAsset.addWithTag("./bin/assets/image/wabbit_alpha.png", ManagerAsset.TYPE_IMAGE, "bunny");
        this.managerAsset.addWithTag("./bin/assets/image/Outdoor_01.png", ManagerAsset.TYPE_IMAGE, "bg");
        this.managerAsset.queueLoad(function () {
            return _this.postPreload();
        });
    }
    Game.prototype.postPreload = function () {
        this.managerSystem.addWithTag(new SystemBunnyMark(this._screenData), "bunnymark", ManagerSystem.PRIORITY_UPDATE);
        this._screenData.setBackgroundImage("./bin/assets/image/Outdoor_01.png", true);
        for(var i = 0; i < this._bunnys; i++) {
            var xpos = Math.random() * (this._screenData.width - 50);
            var ypos = Math.random() * (this._screenData.height - 50);
            var xvelocity = 5 + (Math.random() * 25);
            var yvelocity = 5 + (Math.random() * 25);
            var bunny = new Sprite("bunny" + i, "bunny", false);
            bunny.position.x = 6 + xpos;
            bunny.position.y = 6 + ypos;
            bunny.velocity.x = -(Math.random() * 25) + (xvelocity * 2);
            bunny.velocity.y = -(Math.random() * 25) + (yvelocity * 2);
            bunny.velocity.damping = 1;
        }
        this.setCoreRunning(true);
    };
    return Game;
})(Engine);
