/**
 * Game
 */
class Game extends Engine
{
	// properties
	private _screenData:ScreenData 					= null;
	private _bunnys:number 							= 50;


	// constructor
	constructor(canvas, width, height)
	{
		super(canvas, width, height);

		// Debug
		Debug.debuggingEnabled = false;

		// create the screen bounds
		this._screenData 				= new ScreenData(canvas, width, height);

		// preload assets
		this.managerAsset.addWithTag("./bin/assets/image/wabbit_alpha.png", ManagerAsset.TYPE_IMAGE, "bunny");
		this.managerAsset.addWithTag("./bin/assets/image/Outdoor_01.png", ManagerAsset.TYPE_IMAGE, "bg");
		this.managerAsset.queueLoad(() => this.postPreload());
	}



	public postPreload():void
	{
		// systems init
		this.managerSystem.addWithTag(new SystemBunnyMark(this._screenData), "bunnymark", ManagerSystem.PRIORITY_UPDATE);

		// set a bg
		this._screenData.setBackgroundImage("./bin/assets/image/Outdoor_01.png", true);

		// create bunnys
		for(var i:number = 0; i < this._bunnys; i++)
		{
			// random values
			var xpos:number		 = Math.random() * (this._screenData.width - 50);
			var ypos:number		 = Math.random() * (this._screenData.height - 50);
			var xvelocity:number = 5 + (Math.random() * 25);
			var yvelocity:number = 5 + (Math.random() * 25);

			var bunny:Sprite		= new Sprite("bunny" + i, "bunny", false);
			bunny.position.x 		= 6 + xpos;
			bunny.position.y 		= 6 + ypos;
			bunny.velocity.x 		= -(Math.random() * 25) + (xvelocity * 2);
			bunny.velocity.y 		= -(Math.random() * 25) + (yvelocity * 2);
			bunny.velocity.damping	= 1;
		}

		// start the core
		this.setCoreRunning(true);
	}
}