/**
 * SystemCanvasRenderer
 */
class SystemBunnyMark extends System
{
	// properties
	private _screenData:ScreenData 					= null;
	private _stats									= null;


	// constructor
	constructor(screenData:ScreenData)
	{
		super();

		this._screenData 	= screenData;

		// create the node list
		this.nodelist 		= ManagerSystemNode.instance.getList(NodeMovement);

		// fps
		this._stats 							= new Stats();
		this._stats.domElement.style.position 	= 'absolute';
		this._stats.domElement.style.left 		= '0px';
		this._stats.domElement.style.top 		= '0px';
		this._stats.domElement.style.z 			= 1;

		document.body.appendChild(this._stats.domElement);

		Debug.log("SystemBunnyMark* init complete");
	}


	public start():void
	{
		Debug.log("SystemBunnyMark* start");
	}


	public update(dt:number, t:number):void
	{
		for(var node = this.nodelist.head; node; node = node.next)
		{
			if(node.position.x > this._screenData.width - 30) node.velocity.x *= -1;
			if(node.position.x < 3) node.velocity.x *= -1;

			if(node.position.y > this._screenData.height - 40) node.velocity.y *= -1;
			if(node.position.y < 3) node.velocity.y *= -1;
		}

		this._stats.update();
	}


	public end():void
	{
		Debug.log("SystemBunnyMark* end");
	}
}