var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
}
var SystemKeyboardInput = (function (_super) {
    __extends(SystemKeyboardInput, _super);
    function SystemKeyboardInput(keyInput, screenData) {
        _super.call(this);
        this._keyInput = null;
        this._screenData = null;
        this._keyInput = keyInput;
        this._screenData = screenData;
        this.nodelist = ManagerSystemNode.instance.getList(ShipNode);
        Debug.log("SystemKeyboardInput* init complete");
    }
    SystemKeyboardInput.prototype.start = function () {
        Debug.log("SystemKeyboardInput* start");
    };
    SystemKeyboardInput.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            if(node.velocity.x > 1080) {
                node.velocity.x = 1080;
            }
            if(node.velocity.y > 1080) {
                node.velocity.y = 1080;
            }
            if(this._keyInput.keyIsDown(KeyInput.LEFT)) {
                node.position.rotation -= 140 * dt;
            } else {
                if(this._keyInput.keyIsDown(KeyInput.RIGHT)) {
                    node.position.rotation += 140 * dt;
                }
            }
            if(this._keyInput.keyIsDown(KeyInput.UP)) {
                node.velocity.x += (Math.cos(MathUtils.degreesToRadians(node.position.rotation)) * 254) * dt;
                node.velocity.y += (Math.sin(MathUtils.degreesToRadians(node.position.rotation)) * 254) * dt;
                node.animation.currentAnimationTag = "boost";
            } else {
                node.animation.currentAnimationTag = "noboost";
            }
            if(node.position.x > this._screenData.width + 10) {
                node.position.x = -12;
            } else {
                if(node.position.x < -12) {
                    node.position.x = this._screenData.width + 12;
                }
            }
            if(node.position.y > this._screenData.height + 12) {
                node.position.y = -12;
            } else {
                if(node.position.y < -12) {
                    node.position.y = this._screenData.height + 12;
                }
            }
        }
    };
    SystemKeyboardInput.prototype.end = function () {
        Debug.log("SystemKeyboardInput* end");
    };
    return SystemKeyboardInput;
})(System);
var ShipNode = (function (_super) {
    __extends(ShipNode, _super);
    function ShipNode() {
        _super.apply(this, arguments);

        this.position = null;
        this.velocity = null;
        this.display = null;
        this.animation = null;
    }
    return ShipNode;
})(SystemNode);
var Game = (function (_super) {
    __extends(Game, _super);
    function Game(canvas, width, height) {
        var _this = this;
        _super.call(this, canvas, width, height);
        this._keyInput = null;
        this._screenData = null;
        this._screenData = new ScreenData(canvas, width, height);
        this._keyInput = new KeyInput();
        this.managerAsset.addWithTag("./bin/assets/image/bg.png", ManagerAsset.TYPE_IMAGE, "bg");
        this.managerAsset.addWithTag("./bin/assets/image/ship.png", ManagerAsset.TYPE_ATLAS, "shipAtlas");
        this.managerAsset.queueLoad(function () {
            return _this.postPreload();
        });
    }
    Game.prototype.postPreload = function () {
        this.managerSystem.addWithTag(new SystemKeyboardInput(this._keyInput, this._screenData), "main", ManagerSystem.PRIORITY_INPUT);
        this._screenData.setBackgroundImage("./bin/assets/image/bg.png", false);
        var ship = new Sprite("ship", "shipAtlas", true);
        ship.position.origin.x = 9;
        ship.position.origin.y = 11;
        ship.position.x = 400;
        ship.position.y = 250;
        ship.animation.addWithTag("boost", [
            "asteroids1.png"
        ]);
        ship.animation.addWithTag("noboost", [
            "asteroids0.png"
        ]);
        var shipNode = new ShipNode(ship);
        shipNode.position = ship.position;
        shipNode.display = ship.display;
        shipNode.velocity = ship.velocity;
        shipNode.animation = ship.animation;
        ManagerSystemNode.instance.addToList(shipNode, ShipNode);
        this.setCoreRunning(true);
    };
    return Game;
})(Engine);
