/**
 * SystemOriginPoint
 */
class SystemKeyboardInput extends System
{
	// properties
	private _keyInput:KeyInput 			= null;
	private _screenData:ScreenData 		= null;



	// constructor
	constructor(keyInput:KeyInput, screenData:ScreenData)
	{
		super();

		// store input for use
		this._keyInput 		= keyInput;
		this._screenData 	= screenData;

		// create the node list
		this.nodelist = ManagerSystemNode.instance.getList(ShipNode);

		Debug.log("SystemKeyboardInput* init complete");
	}



	public start():void
	{
		Debug.log("SystemKeyboardInput* start");
	}



	public update(dt:number, t:number):void
	{
		for(var node = this.nodelist.head; node; node = node.next)
		{
			// velocity limits
			if(node.velocity.x > 1080) node.velocity.x = 1080;
			if(node.velocity.y > 1080) node.velocity.y = 1080;

			// move
			if(this._keyInput.keyIsDown(KeyInput.LEFT))
			{
				node.position.rotation -= 140 * dt;
			} else if(this._keyInput.keyIsDown(KeyInput.RIGHT))
			{
				node.position.rotation += 140 * dt;
			}

			if(this._keyInput.keyIsDown(KeyInput.UP))
			{
				node.velocity.x += (Math.cos(MathUtils.degreesToRadians(node.position.rotation)) * 254) * dt;
				node.velocity.y += (Math.sin(MathUtils.degreesToRadians(node.position.rotation)) * 254) * dt;

				node.animation.currentAnimationTag = "boost";
			} else
			{
				node.animation.currentAnimationTag = "noboost";
			}

			// wrap screen bounds
			if(node.position.x > this._screenData.width + 10)
			{
				node.position.x = -12;
			} else if(node.position.x < -12)
			{
				node.position.x = this._screenData.width + 12;
			}

			if(node.position.y > this._screenData.height + 12)
			{
				node.position.y = -12;
			} else if(node.position.y < -12)
			{
				node.position.y = this._screenData.height + 12;
			}
		}
	}



	public end():void
	{
		Debug.log("SystemKeyboardInput* end");
	}
}