var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
}
var SystemOriginPoint = (function (_super) {
    __extends(SystemOriginPoint, _super);
    function SystemOriginPoint() {
        _super.call(this);
        this.nodelist = ManagerSystemNode.instance.getList(NodeLogic);
        Debug.log("SystemOriginPoint* init complete");
    }
    SystemOriginPoint.prototype.start = function () {
        Debug.log("SystemOriginPoint* start");
    };
    SystemOriginPoint.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            node.position.rotation += 60 * dt;
        }
    };
    SystemOriginPoint.prototype.end = function () {
        Debug.log("SystemOriginPoint* end");
    };
    return SystemOriginPoint;
})(System);
var Game = (function (_super) {
    __extends(Game, _super);
    function Game(canvas, width, height) {
        var _this = this;
        _super.call(this, canvas, width, height);
        this._screenData = null;
        this._screenData = new ScreenData(canvas, width, height);
        this._screenData.canvas.width = width;
        this._screenData.canvas.height = height;
        this.managerAsset.addWithTag("./bin/assets/image/bg.png", ManagerAsset.TYPE_IMAGE, "bg");
        this.managerAsset.addWithTag("./bin/assets/image/invader.png", ManagerAsset.TYPE_IMAGE, "invader");
        this.managerAsset.addWithTag("./bin/assets/image/animatedInvader.png", ManagerAsset.TYPE_ATLAS, "invaderAtlas");
        this.managerAsset.queueLoad(function () {
            return _this.postPreload();
        });
    }
    Game.prototype.postPreload = function () {
        this.managerSystem.addWithTag(new SystemOriginPoint(), "main", ManagerSystem.PRIORITY_UPDATE);
        this._screenData.setBackgroundImage("./bin/assets/image/bg.png", true);
        var invader = this.createInvader("invaderEntity", false, false, 175, 257);
        var invaderCentre = this.createInvader("invaderEntityCentre", false, true, 378, 257);
        var invaderCentreAtlas = this.createInvader("invaderEntityCentreAtlas", true, true, 587, 258);
        this.setCoreRunning(true);
    };
    Game.prototype.createInvader = function (tag, animated, centreOrigin, x, y) {
        var invader;
        if(animated) {
            invader = new Sprite(tag, "invaderAtlas", animated);
            invader.animation.addWithTag("idle", [
                "invader.png", 
                "invader1.png"
            ]);
            invader.animation.currentAnimationTag = "idle";
            invader.animation.frameskip = 14;
        } else {
            invader = new Sprite(tag, "invader", animated);
        }
        var invaderNode = new NodeLogic(invader);
        invaderNode.position = invader.position;
        invaderNode.display = invader.display;
        ManagerSystemNode.instance.addToList(invaderNode, NodeLogic);
        if(centreOrigin) {
            invader.position.origin.x = 22;
            invader.position.origin.y = 16;
        }
        invader.position.x = x;
        invader.position.y = y;
        return invader;
    };
    return Game;
})(Engine);
