var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var SystemSimpleCollison = (function (_super) {
    __extends(SystemSimpleCollison, _super);
    function SystemSimpleCollison(screenData) {
        _super.call(this);
        this._screenData = null;
        this._screenData = screenData;
        this.nodelist = ManagerSystemNode.instance.getList(AsteroidNode);
        Debug.log("SystemSimpleCollison* init complete");
    }
    SystemSimpleCollison.prototype.start = function () {
        Debug.log("SystemSimpleCollison* start");
    };
    SystemSimpleCollison.prototype.update = function (dt, t) {
        for(var node = this.nodelist.head; node; node = node.next) {
            for(var othernode = this.nodelist.head; othernode; othernode = othernode.next) {
                if(othernode != node) {
                    var dist = Math.sqrt((node.position.x - othernode.position.x) * (node.position.x - othernode.position.x) + (node.position.y - othernode.position.y) * (node.position.y - othernode.position.y));
                    if(dist < (node.display.width / 2 + othernode.display.width / 2)) {
                        node.velocity.x = 0;
                        node.velocity.y = 0;
                        othernode.velocity.x = 0;
                        othernode.velocity.y = 0;
                    }
                }
            }
            if(node.position.x > this._screenData.width + 10) {
                node.position.x = -12;
            } else {
                if(node.position.x < -12) {
                    node.position.x = this._screenData.width + 12;
                }
            }
            if(node.position.y > this._screenData.height + 12) {
                node.position.y = -12;
            } else {
                if(node.position.y < -12) {
                    node.position.y = this._screenData.height + 12;
                }
            }
        }
    };
    SystemSimpleCollison.prototype.end = function () {
        Debug.log("SystemKeyboardInput* end");
    };
    return SystemSimpleCollison;
})(System);
var AsteroidNode = (function (_super) {
    __extends(AsteroidNode, _super);
    function AsteroidNode() {
        _super.apply(this, arguments);

        this.position = null;
        this.velocity = null;
        this.display = null;
        this.animation = null;
    }
    return AsteroidNode;
})(SystemNode);
var Game = (function (_super) {
    __extends(Game, _super);
    function Game(canvas, width, height) {
        var _this = this;
        _super.call(this, canvas, width, height);
        this._keyInput = null;
        this._screenData = null;
        this._screenData = new ScreenData(canvas, width, height);
        this._keyInput = new KeyInput();
        this.managerAsset.addWithTag("./bin/assets/image/bg.png", ManagerAsset.TYPE_IMAGE, "bg");
        this.managerAsset.addWithTag("./bin/assets/image/asteroid.png", ManagerAsset.TYPE_ATLAS, "asteroidAtlas");
        this.managerAsset.queueLoad(function () {
            return _this.postPreload();
        });
    }
    Game.prototype.postPreload = function () {
        this.managerSystem.addWithTag(new SystemSimpleCollison(this._screenData), "main", ManagerSystem.PRIORITY_INPUT);
        this._screenData.setBackgroundImage("./bin/assets/image/bg.png", false);
        for(var i = 0; i < 10; i++) {
            var asteroid = new Sprite("asteroid" + i, "asteroidAtlas", true);
            asteroid.position.x = Math.random() * this._screenData.width;
            asteroid.position.y = Math.random() * this._screenData.height;
            asteroid.position.origin.x = 9;
            asteroid.position.origin.y = 11;
            asteroid.velocity.x = -50 + Math.random() * 100;
            asteroid.velocity.y = -50 + Math.random() * 100;
            asteroid.velocity.damping = 1;
            asteroid.animation.addWithTag("type1", [
                "asteroid1.png"
            ]);
            asteroid.animation.addWithTag("type2", [
                "asteroid2.png"
            ]);
            asteroid.animation.addWithTag("type3", [
                "asteroid3.png"
            ]);
            asteroid.animation.addWithTag("type4", [
                "asteroid4.png"
            ]);
            var frame = Math.round(Math.random() * 3) + 1;
            asteroid.animation.currentAnimationTag = "type" + frame;
            var asteroidNode = new AsteroidNode(asteroid);
            asteroidNode.position = asteroid.position;
            asteroidNode.display = asteroid.display;
            asteroidNode.velocity = asteroid.velocity;
            asteroidNode.animation = asteroid.animation;
            ManagerSystemNode.instance.addToList(asteroidNode, AsteroidNode);
        }
        this.setCoreRunning(true);
    };
    return Game;
})(Engine);
