/**
 * SystemSimpleCollison
 */
class SystemSimpleCollison extends System
{
	// properties
	private _screenData:ScreenData 		= null;



	// constructor
	constructor(screenData:ScreenData)
	{
		super();

		// store for use
		this._screenData 	= screenData;

		// create the node list
		this.nodelist = ManagerSystemNode.instance.getList(AsteroidNode);

		Debug.log("SystemSimpleCollison* init complete");
	}



	public start():void
	{
		Debug.log("SystemSimpleCollison* start");
	}



	public update(dt:number, t:number):void
	{
		for(var node = this.nodelist.head; node; node = node.next)
		{
			for(var othernode = this.nodelist.head; othernode; othernode = othernode.next)
			{
				if(othernode != node)
				{
					// distance to
					var dist:number = Math.sqrt((node.position.x - othernode.position.x) * (node.position.x - othernode.position.x) + (node.position.y - othernode.position.y) * (node.position.y - othernode.position.y));
					if(dist < (node.display.width/2 + othernode.display.width/2))
					{
						node.velocity.x 		= 0;
						node.velocity.y 		= 0;
						othernode.velocity.x 	= 0;
						othernode.velocity.y 	= 0;
					}
				}
			}

			// wrap screen bounds
			if(node.position.x > this._screenData.width + 10)
			{
				node.position.x = -12;
			} else if(node.position.x < -12)
			{
				node.position.x = this._screenData.width + 12;
			}

			if(node.position.y > this._screenData.height + 12)
			{
				node.position.y = -12;
			} else if(node.position.y < -12)
			{
				node.position.y = this._screenData.height + 12;
			}
		}
	}



	public end():void
	{
		Debug.log("SystemKeyboardInput* end");
	}
}