/**
 * Game
 */
class Game extends Engine
{
	// properties
	private _screenData:ScreenData 				= null;


	// constructor
	constructor(canvas, width, height)
	{
		super(canvas, width, height);

		// Debug
		//Debug.debuggingEnabled = false;

		// create the screen bounds
		this._screenData 		= new ScreenData(canvas, width, height);

		// set screen bounds
		this._screenData.canvas.width 	= width;
		this._screenData.canvas.height 	= height;

		// preload assets
		this.managerAsset.addWithTag("./bin/assets/image/ryubg.png", ManagerAsset.TYPE_IMAGE, "bg");
		this.managerAsset.addWithTag("./bin/assets/image/ryuCPS2.png", ManagerAsset.TYPE_ATLAS, "ryu");
		this.managerAsset.addWithTag("./bin/assets/image/guileCPS2.png", ManagerAsset.TYPE_ATLAS, "guile");
		this.managerAsset.queueLoad(() => this.postPreload());
	}



	public postPreload():void
	{
		// add bg
		this._screenData.setBackgroundImage("./bin/assets/image/ryubg.png", false);

		// create entities
		var ryu:Sprite 			= new Sprite("EntityRyu", "ryu", true);
		ryu.animation.addWithTag("idle", ['ryu-cvs2-stance1.png','ryu-cvs2-stance2.png','ryu-cvs2-stance3.png', 'ryu-cvs2-stance4.png','ryu-cvs2-stance5.png', 'ryu-cvs2-stance6.png']);
		ryu.animation.currentAnimationTag = "idle";
		ryu.animation.frameskip = 5;
		ryu.position.x 			= 220;
		ryu.position.y 			= 210;


		var guile:Sprite 			= new Sprite("EntityGuile", "guile", true);
		guile.animation.addWithTag("idle", ['guile-oldstance1.png','guile-oldstance2.png','guile-oldstance3.png', 'guile-oldstance4.png','guile-oldstance5.png']);
		guile.animation.currentAnimationTag = "idle";
		guile.animation.frameskip 	= 5;
		guile.position.x 			= 620;
		guile.position.y 			= 240;

		// start the core
		this.setCoreRunning(true);
	}
}